package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.CreateMediaPlayer;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Cursor;
import javafx.scene.layout.BorderPane;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class CreditsController implements Initializable {
    @FXML
    private BorderPane parent;
    @FXML
    private MediaView mediaView;
    private MediaPlayer mediaPlayer;
    private final File file = new File("src/main/resources/videos/credits.mp4");

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        parent.setStyle("-fx-background-color: black;");
        parent.setCursor(Cursor.NONE);
        createMediaPlayer();
    }

    private void createMediaPlayer() {
        mediaPlayer = new CreateMediaPlayer().getMediaPlayer(mediaView, file, true, parent);
        mediaView.setMediaPlayer(mediaPlayer);

        mediaPlayer.setOnEndOfMedia(this::videoEnd);

        parent.setOnMouseClicked(mouseEvent -> videoEnd());
    }

    private void videoEnd() {
        try {
//            I don't know how to return to the options scene, so it just goes back to the main menu :(
            mediaPlayer.dispose();
            parent.getChildren().clear();
            parent.getScene().setRoot(FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/MenuBorderPane.fxml"))));
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }
}
