package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TitledPane;
import javafx.scene.control.ToggleButton;
import javafx.scene.control.ToggleGroup;
import javafx.scene.layout.VBox;

import java.net.URL;
import java.util.ResourceBundle;

public class LocalCreateController implements Initializable {
    @FXML
    private VBox parent;
    @FXML
    private TitledPane roundsTitledPane;
    @FXML
    private ToggleGroup rounds;
    private final SceneLoader sceneLoader = new SceneLoader();

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        rounds.selectedToggleProperty().addListener((observableValue, oldToggle, newToggle) -> {
            if (rounds.getSelectedToggle() != null) {
                ToggleButton selected = (ToggleButton) rounds.getSelectedToggle();
                roundsTitledPane.setText(selected.getText());
            }
        });
    }
    @FXML
    private void backButton() {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene("Play"));
    }

    @FXML
    private void skinSelectionScene() {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene("SkinSelection"));
    }

}
