package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Exceptions.DatabaseException;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Persistence;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.layout.VBox;
import javafx.stage.Screen;
import javafx.stage.Stage;

import java.net.URL;
import java.util.ResourceBundle;

public class MainMenuController implements Initializable {
    @FXML
    private VBox parent;
    @FXML
    private Button exitButton;
    private final SceneLoader sceneLoader = new SceneLoader();
    private final Persistence persistence = Persistence.getInstance();

    private void switchScene(String name) {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene(name));
    }

    @FXML
    private void playScene() {
        switchScene("Play");
    }

    @FXML
    private void mapScene() {
        switchScene("MapForge");
    }

    @FXML
    private void statisticsScene() {
        switchScene("Statistics");
    }

    @FXML
    private void settingsScene() {
        switchScene("Settings");
    }

    @FXML
    private void exit() throws DatabaseException {
        persistence.savePlayerStatistics();
        persistence.saveSettings();
        Stage stage = (Stage) exitButton.getScene().getWindow();
        stage.close();
    }

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
//        Screen screen = Screen.getPrimary();
//        if (screen.getDpi() >= 119) {
//            parent.setSpacing(30);
//            parent.setStyle("-fx-font-size: 40");
//        } else {
//            parent.setStyle("-fx-font-size: 50");
//        }
    }
}
