package de.hdm_stuttgart.battlearena.Controller.Utilities;

import javafx.fxml.FXMLLoader;
import javafx.scene.layout.Pane;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.net.URL;

public class SceneLoader {

    private static final Logger log = LogManager.getLogger(SceneLoader.class);

    private Pane view;

    //helper method for loading fxml files in the scene
    public Pane loadScene(String fileName) {
        try {
            URL filePath = getClass().getResource("/fxml/" + fileName + ".fxml");

            if (filePath == null) {
                throw new java.io.FileNotFoundException(fileName + " not found");
            }

            new FXMLLoader();
            view = FXMLLoader.load(filePath);

        } catch (Exception e) {
            log.debug("Scene " + fileName + " not found");
        }
        return view;
    }

}