package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Utilities;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Exceptions.CryptoException;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.*;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;

import java.nio.charset.StandardCharsets;


public class CryptoUtils{
    private static String parts[] = new String[2];
    private static final String ALGORITHM = "AES";
    private static final String TRANSFORMATION = "AES/ECB/PKCS5Padding";
    private static String key = "Peters Olivenöl";
    private static String  encrypted_as_word = "encrypted;";
    private static boolean alreadyencrypted = false;
    private static boolean multipleencryptions = false;
    private static int encryptionreturn;

    private static final Logger log = LogManager.getLogger(CryptoUtils.class);


    public static int encrypt(File inputFile,  boolean multipleencryptions) throws CryptoException {
        alreadyencrypted = check_if_file_already_encrypted(inputFile);
        if(multipleencryptions){
            doCrypto(Cipher.ENCRYPT_MODE, key, inputFile);
            log.info("This File can be encrypted multiple times");
            return encryptionreturn = 0;
        }
        else if(!alreadyencrypted && !multipleencryptions){
            doCrypto(Cipher.ENCRYPT_MODE, key, inputFile);
            log.info("This File can only be encryptet once and this is now!");
            return encryptionreturn = 1;
        }else {
            log.info("This file is already encrypted and doesnt need to be encrypted anymore! " + inputFile);
            return encryptionreturn = 2;
        }
    }

    public static String[] decrypt(File inputFile) throws CryptoException {
        doCrypto(Cipher.DECRYPT_MODE, key, inputFile);
        return parts;
    }

    private static String[] doCrypto(int cipherMode, String key, File inputFile) throws CryptoException {
        try {
            Key secretKey = new SecretKeySpec(key.getBytes(), ALGORITHM);
            Cipher cipher = Cipher.getInstance(TRANSFORMATION);
            cipher.init(cipherMode, secretKey);

            FileInputStream inputStream = new FileInputStream(inputFile);
            byte[] inputBytes = new byte[(int) inputFile.length()];
            inputStream.read(inputBytes);   //liest from inputstream into BufferArray

            byte[] outputBytes = cipher.doFinal(inputBytes);

            String completeString = new String(outputBytes, StandardCharsets.UTF_8);
            //log.info("completeString/outputBytes: " + completeString);
            parts = completeString.split(";");

                if(cipherMode == Cipher.ENCRYPT_MODE){
                    FileOutputStream outputStream = new FileOutputStream(inputFile);
                    outputStream.write(outputBytes);//outputBytes
                    outputStream.close();
                    multipleencryptions = true;
                }
            inputStream.close();

        } catch (NoSuchPaddingException | NoSuchAlgorithmException
                 | InvalidKeyException | BadPaddingException
                 | IllegalBlockSizeException | IOException ex) {
            throw new CryptoException("Error encrypting/decrypting file", ex);
        }
        return parts;
    }
    public static boolean check_if_file_already_encrypted(File inputFile){
        String filename =  inputFile.getName();
        //log.info("filename: " + filename);
            if(filename.contains(encrypted_as_word)){
                return alreadyencrypted =true;
            }
        inputFile.renameTo(new File("src\\main\\resources\\database\\" + encrypted_as_word + filename));
        return alreadyencrypted = false;
    }

       /*public static String[] doCrypto(int cipherMode, String key, File inputFile) throws CryptoException {
        try {

            String filename = inputFile.getName();
            //String encrypted_as_word = "encrypted;";
            byte[] encryptet_as_word_as_bytes = encrypted_as_word.getBytes();

            Key secretKey = new SecretKeySpec(key.getBytes(), ALGORITHM);
            Cipher cipher = Cipher.getInstance(TRANSFORMATION);
            cipher.init(cipherMode, secretKey);

            FileInputStream inputStream = new FileInputStream(inputFile);
            byte[] inputBytes = new byte[(int) inputFile.length()];
            inputStream.read(inputBytes);   //liest from inputstream into BufferArray

            String inputbytes = new String(inputBytes, StandardCharsets.UTF_8);
            String[] wellencrypted = inputbytes.split(";");

            log.info("encrypted_as_word.substring(0,encrypted_as_word.length()-1): " + encrypted_as_word.substring(0,encrypted_as_word.length()-1));

            if(wellencrypted[0].equals(encrypted_as_word.substring(0,encrypted_as_word.length()-1))){
                wellencrypted = Arrays.copyOfRange(wellencrypted,1,wellencrypted.length);
                inputBytes = wellencrypted[0].getBytes();
                log.info("Das Wort encrypted ist enthalten!");
                log.info("inputBytes: " + new String(inputBytes, StandardCharsets.UTF_8));

            }
            log.info("wellencrypted[0]: " +wellencrypted[0]);
            log.info("wel[0]: " + wel[0]);
             log.info("inputbytes: " + inputbytes);
            log.info("inputBytes: " + new String(inputBytes, StandardCharsets.UTF_8));

            byte[] outputBytes = cipher.doFinal(inputBytes);


            String completeString = new String(outputBytes, StandardCharsets.UTF_8);
            log.info("completeString/outputBytes: " + completeString);
            parts = completeString.split(";");

                if(cipherMode == Cipher.ENCRYPT_MODE){
                    FileOutputStream outputStream = new FileOutputStream(inputFile);
                    ByteArrayOutputStream outputStream12 = new ByteArrayOutputStream( );
                    outputStream12.write(encryptet_as_word_as_bytes);
                    outputStream12.write(outputBytes);
                    byte combined[] = outputStream12.toByteArray( );
                    String combinedbytes = new String(combined, StandardCharsets.UTF_8);
                    log.info("combined: " + combinedbytes);


                    outputStream.write(combined);//outputBytes

                    outputStream.close();
                }

            inputStream.close();

        } catch (NoSuchPaddingException | NoSuchAlgorithmException
                 | InvalidKeyException | BadPaddingException
                 | IllegalBlockSizeException | IOException ex) {
            throw new CryptoException("Error encrypting/decrypting file", ex);
        }
        return parts;
    }*/
}
