package de.hdm_stuttgart.battlearena.Model.Inputs;

import de.hdm_stuttgart.battlearena.Model.Sound.SoundEffects;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

public class InputHandler {

    private static final Logger log = LogManager.getLogger(InputHandler.class);

    private static final InputHandler inputHandler = new InputHandler();

    private InputHandler(){}

    public static InputHandler getInstance() {
        return inputHandler;
    }

    //general input
    private boolean isPause = false;

    //Local + Network Player one controls
    private boolean moveUp, moveDown, moveLeft, moveRight, attack, bomb;

    //Local player two controls
    private boolean sdMoveUp, sdMoveDown, sdMoveLeft, sdMoveRight, sdAttack, sdBomb;

    public void handleKeyPress(KeyEvent event) {
        KeyCode code = event.getCode();

        switch (code) {
            case ESCAPE:
                isPause = !isPause;
                log.debug("Pause button pressed");
                break;
            case W:
                moveUp = true;
                log.debug("Player one move up");
                break;
            case S:
                moveDown = true;
                log.debug("Player one move down");
                break;
            case A:
                moveLeft = true;
                log.debug("Player one move left");
                break;
            case D:
                moveRight = true;
                log.debug("Player one move right");
                break;
            case E:
                attack = true;
                log.debug("Player one attack");
                break;
            case Q:
                bomb = true;
                break;
            //inputs for second player
            case UP:
                sdMoveUp = true;
                break;
            case DOWN:
                sdMoveDown = true;
                break;
            case LEFT:
                sdMoveLeft = true;
                break;
            case RIGHT:
                sdMoveRight = true;
                break;
            case MINUS:
                sdAttack = true;
                break;
            case CONTROL:
                sdBomb = true;
                break;
        }
    }

    public void handleKeyRelease(KeyEvent event) {
        KeyCode code = event.getCode();

        switch (code) {
            case W:
                moveUp = false;
                break;
            case S:
                moveDown = false;
                break;
            case A:
                moveLeft = false;
                break;
            case D:
                moveRight = false;
                break;
            case E:
                attack = false;
                break;
            case Q:
                bomb = false;
                break;
            //inputs for second player
            case UP:
                sdMoveUp = false;
                break;
            case DOWN:
                sdMoveDown = false;
                break;
            case LEFT:
                sdMoveLeft = false;
                break;
            case RIGHT:
                sdMoveRight = false;
                break;
            case MINUS:
                sdAttack = false;
                break;
            case CONTROL:
                sdBomb = false;
                break;
        }
    }

    public boolean isPause() {
        return isPause;
    }

    public void setPause(boolean pause) {
        isPause = pause;
    }

    public boolean isMoveUp() {
        return moveUp;
    }

    public boolean isMoveDown() {
        return moveDown;
    }

    public boolean isMoveLeft() {
        return moveLeft;
    }

    public boolean isMoveRight() {
        return moveRight;
    }

    public boolean isAttack() {
        return attack;
    }

    public boolean isSdMoveUp() {
        return sdMoveUp;
    }

    public boolean isSdMoveDown() {
        return sdMoveDown;
    }

    public boolean isSdMoveLeft() {
        return sdMoveLeft;
    }

    public boolean isSdMoveRight() {
        return sdMoveRight;
    }

    public boolean isSdAttack() {
        return sdAttack;
    }

    public boolean isBomb(){
        return bomb;
    }

    public boolean isSdBomb(){
        return sdBomb;
    }
}