package de.hdm_stuttgart.battlearena.Model.Multiplayer;

import de.hdm_stuttgart.battlearena.Model.Entity.EntityClass;
import de.hdm_stuttgart.battlearena.Model.Entity.EntityDirection;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.IOException;
import java.util.Arrays;
import java.util.concurrent.TimeUnit;

public class ConnectionHandler {

    private static int pX = 0;
    private static int pY = 0;
    private static int enemyX = 0;
    private static int enemyY = 0;
    private static int playerID = 0;

    private static int playerAttacking = 1;
    private static int enemyAttacking = 0;
    private static int playerClass = 0;
    private static int enemyClass = 0;
    private static int playerWalkDirection = 2;
    private static int enemyWalkDirection = 0;
    private static int playerHealth = 10;
    private static int enemyHealth = 10;
    private static int[] coordinates = {pX,pY,playerID,playerAttacking,playerClass,playerWalkDirection,playerHealth};
    private static String ipaddress = "localhost";
    private static final Logger log = LogManager.getLogger(ConnectionHandler.class);

    public void startHandler() throws IOException, InterruptedException {

        Client client = new Client();
        client.startConnection(ipaddress, 4444);

        ConnectionThread connectionthread = new ConnectionThread(client);
        connectionthread.start();

    }

    private static class ConnectionThread extends Thread {
        private final Client client;

        public ConnectionThread(Client client) {
            this.client = client;
        }

        public void run() {
            try {
                while (!Thread.interrupted()) {
                    int[] cords = client.sendcords(coordinates);
                    enemyX = cords[0];
                    enemyY = cords[1];
                    playerID = cords[2];
                    enemyAttacking = cords[3];
                    enemyClass = cords[4];
                    enemyWalkDirection = cords[5];
                    enemyHealth = cords[6];
                    // Assign the Values to the message to send:
                    coordinates[0] = pX;
                    coordinates[1] = pY;
                    coordinates[2] = playerID;
                    coordinates[3] = playerAttacking;
                    coordinates[4] = playerClass;
                    coordinates[5] = playerWalkDirection;
                    coordinates[6] = playerHealth;
                    Thread.sleep(50);
                }
            } catch (InterruptedException | IOException e) {
                e.printStackTrace(); // Handle the exception as needed
            }
        }
    }

    public int getPlayerID() {
        return playerID;
    }

    public int getpX() {
        return pX;
    }

    public void setpX(int pX) {
        this.pX = pX;
    }

    public int getpY() {
        return pY;
    }

    public void setpY(int pY) {
        this.pY = pY;
    }

    public int getEnemyX() {

        return enemyX;
    }
    public int getEnemyY() {

        return enemyY;
    }

    //Getters and Setter for all other information that are not coordinates:

    public static boolean getPlayerAttacking() {
        if (playerAttacking == 1){
            return true;
        } else {
            return false;
        }
    }

    public static void setPlayerAttacking(boolean attack) {
        if (attack){
            ConnectionHandler.playerAttacking = 1;
        } else {
            ConnectionHandler.playerAttacking = 0;
        }
    }

    public static boolean getEnemyAttacking() {
        if (enemyAttacking == 1){
            return true;
        } else {
            return false;
        }
    }

    public static void setEnemyAttacking(boolean attack) {
        if (attack){
            ConnectionHandler.enemyAttacking = 1;
        } else {
            ConnectionHandler.enemyAttacking = 0;
        }
    }

    public static EntityClass getPlayerClass() {
        if (playerClass == 1) {
            return EntityClass.HIGH_BORN;
        } else if (playerClass == 2) {
            return EntityClass.LOW_BORN;
        } else if (playerClass == 3) {
            return EntityClass.SENTINELS;
        } else {
            return EntityClass.HUMAN;
        }
    }

    public static void setPlayerClass(EntityClass player) {
        if (player == EntityClass.HUMAN){
            ConnectionHandler.playerClass = 0;
        } else if (player == EntityClass.HIGH_BORN) {
            ConnectionHandler.playerClass = 1;
        } else if (player == EntityClass.LOW_BORN){
            ConnectionHandler.playerClass = 2;
        } else {
            ConnectionHandler.playerClass = 3;
        }
    }

    public static EntityClass getEnemyClass() {
        if (enemyClass == 1) {
            return EntityClass.HIGH_BORN;
        } else if (enemyClass == 2) {
            return EntityClass.LOW_BORN;
        } else if (enemyClass == 3) {
            return EntityClass.SENTINELS;
        } else {
            return EntityClass.HUMAN;
        }
    }

    public static void setEnemyClass(EntityClass player) {
        if (player == EntityClass.HUMAN){
            ConnectionHandler.enemyClass = 0;
        } else if (player == EntityClass.HIGH_BORN) {
            ConnectionHandler.enemyClass = 1;
        } else if (player == EntityClass.LOW_BORN){
            ConnectionHandler.enemyClass = 2;
        } else {
            ConnectionHandler.enemyClass = 3;
        }
    }

    public static EntityDirection getPlayerWalkDirection() {
        if (playerWalkDirection == 1){
            return EntityDirection.RIGHT;
        } else if (playerWalkDirection == 2){
            return EntityDirection.DOWN;
        } else if (playerWalkDirection == 3){
            return EntityDirection.LEFT;
        } else {
            return EntityDirection.UP;
        }
    }

    public static void setPlayerWalkDirection(EntityDirection walk) {
        if (walk == EntityDirection.RIGHT) {
            ConnectionHandler.playerWalkDirection = 1;
        } else if (walk == EntityDirection.DOWN) {
            ConnectionHandler.playerWalkDirection = 2;
        } else if (walk == EntityDirection.LEFT) {
            ConnectionHandler.playerWalkDirection = 3;
        } else {
            ConnectionHandler.playerWalkDirection = 0;
        }
    }

    public static EntityDirection getEnemyWalkDirection() {
        if (enemyWalkDirection == 1){
            return EntityDirection.RIGHT;
        } else if (enemyWalkDirection == 2){
            return EntityDirection.DOWN;
        } else if (enemyWalkDirection == 3){
            return EntityDirection.LEFT;
        } else {
            return EntityDirection.UP;
        }
    }

    public static void setEnemyWalkDirection(EntityDirection walk) {
        if (walk == EntityDirection.RIGHT) {
            ConnectionHandler.enemyWalkDirection = 1;
        } else if (walk == EntityDirection.DOWN) {
            ConnectionHandler.enemyWalkDirection = 2;
        } else if (walk == EntityDirection.LEFT) {
            ConnectionHandler.enemyWalkDirection = 3;
        } else {
            ConnectionHandler.enemyWalkDirection = 0;
        }
    }

    public static int getPlayerHealth() {
        return playerHealth;
    }

    public static void setPlayerHealth(int playerHealth) {
        ConnectionHandler.playerHealth = playerHealth;
    }

    public static int getEnemyHealth() {
        return enemyHealth;
    }

    public static void setEnemyHealth(int enemyHealth) {
        ConnectionHandler.enemyHealth = enemyHealth;
    }

    public static void setIpaddress(String ipaddress) {
        ConnectionHandler.ipaddress = ipaddress;
    }
}

